/* $%BEGINLICENSE%$
 Copyright (c) 2012, Oracle and/or its affiliates. All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; version 2 of the
 License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 02110-1301  USA

 $%ENDLICENSE%$ */


#ifndef _ADMIN_PLUGIN_STATS_H_
#define _ADMIN_PLUGIN_STATS_H_

#include "network-mysqld-packet.h"
#include "network-mysqld-lua.h"
#include "chassis-plugin.h"

/**
 * admin_plugin_stats_query_t:
 * @STATS_QUERY_SUCCESS: sucess
 * @STATS_QUERY_ERROR: error
 * @STATS_QUERY_ALL_GLOBAL: all gathered statistics for mysql-proxy and loaded plugins
 * @STATS_QUERY_ALL_ADMIN: all gathered statistics for the admin plugin
 * @STATS_QUERY_ALL_PROXY: all gathered statistics for the proxy plugin
 * @STATS_QUERY_UPTIME_GLOBAL: uptime statistics for mysql-proxy
 * @STATS_QUERY_UPTIME_ADMIN: uptime statistics for the admin plugin
 * @STATS_QUERY_UPTIME_PROXY: uptime statistics for the proxy plugi
 * @STATS_QUERY_INCOMPLETE: incomplete query
 * @STATS_QUERY_HELP: helper
 * 
 * return state for received query on the statistics interface
 */
typedef enum {
	STATS_QUERY_SUCCESS,
	STATS_QUERY_ERROR,
	STATS_QUERY_STATS_AVAILABLE,
	STATS_QUERY_STATS_BACKENDS,
	STATS_QUERY_ALL_GLOBAL,
	STATS_QUERY_ALL_ADMIN,
	STATS_QUERY_ALL_PROXY,
	STATS_QUERY_UPTIME_ADMIN,
	STATS_QUERY_UPTIME_PROXY,
	STATS_QUERY_UPTIME_ALL,
	STATS_QUERY_CONNECTIONS_ALL,
	STATS_QUERY_CONNECTIONS_CURRENT,
	STATS_QUERY_CONNECTIONS_MAX,
	STATS_QUERY_LATENCY_ALL,
	STATS_QUERY_LATENCY_AVG,
	STATS_QUERY_LATENCY_MIN,
	STATS_QUERY_LATENCY_MAX,
	STATS_QUERY_INCOMPLETE,
	STATS_QUERY_HELP
} admin_plugin_stats_query_t;

/**
 * plugin_stats_aux:
 * @stat: statistic string identifier
 * @value: statistic value
 * @plugin: plugin string identifier
 *
 * auxiliary struct to map plugin with statistic and corresponding value
 */
typedef struct {
	gchar *stat;
	void *value;
	gchar *plugin;
} plugin_stats_aux;

network_mysqld_lua_stmt_ret admin_stats_handler(chassis G_GNUC_UNUSED *chas, network_mysqld_con *con, admin_plugin_stats_query_t ret);

#endif /* _ADMIN_PLUGIN_STATS_H_ */