/* $%BEGINLICENSE%$
 Copyright (c) 2012, Oracle and/or its affiliates. All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; version 2 of the
 License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 02110-1301  USA

 $%ENDLICENSE%$ */
 

#ifndef _ADMIN_SQL_PARSER_H_
#define _ADMIN_SQL_PARSER_H_

#define YYSTYPE sql_token *

#include "lib/sql-tokenizer.h"

/**
 * sql_tokenizer_t:
 * @tokens: GPtrArray of tokens
 * @current_token: current token
 *
 * struct to store the parser tokens and keep track of the current one
 */
typedef struct {
	GPtrArray *tokens;
	int current_token;
} sql_tokenizer_t;

int yylex(YYSTYPE *lvalp, sql_tokenizer_t *tokenizer);

void yyerror(sql_tokenizer_t *tokenizer, char const *);

sql_tokenizer_t *sql_tokenizer_new(const char *str, gsize str_len);

int yyparse (sql_tokenizer_t *tokenizer);

#endif /* _ADMIN_SQL_PARSER_H */